package com.jpattern.orm.generator.reflection;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;

import com.jpattern.orm.generator.wrapper.TypeWrapper;

/**
 * 
 * Get the value of bean a using directly accessing it
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class FieldWrappedGetFieldManipulator extends AGetFieldManipulator {

	private final Field field;
	private final TypeWrapper<Object, Object> wrapper;

	public FieldWrappedGetFieldManipulator(Field field, TypeWrapper<Object, Object> wrapper) {
		this.field = field;
		this.wrapper = wrapper;
		field.setAccessible(true);
	}

	@Override
	public Object getValue(Object bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		return wrapper.unWrap(field.get(bean));
	}

}
