package com.jpattern.orm.logger;

import com.jpattern.logger.ILogger;
import com.jpattern.logger.ILoggerFactory;
import com.jpattern.logger.NullLoggerFactory;
import com.jpattern.logger.Slf4JLoggerFactory;

/**
 * 
 * @author Francesco Cina
 *
 * 04/giu/2011
 */
public abstract class OrmLogger  {

	private static ILoggerFactory ormLoggerFactory;

	public static void setOrmLoggerFactory(final ILoggerFactory ormLoggerFactory) {
		OrmLogger.ormLoggerFactory = ormLoggerFactory;
	}

	public static ILogger getOrmLogger(final Class<?> clazz) {
		if ( ormLoggerFactory == null ) {
			try {
				ormLoggerFactory = new Slf4JLoggerFactory();
				//Here a class not found exception could be thrown
				ormLoggerFactory.logger(clazz);
			} catch (Throwable e) {
				System.err.println("JPOrm warning: Slf4J library not found in classpath. Include it or set a different ILoggerFactory through " + OrmLogger.class.getCanonicalName() + "'s setLoggerFactory method");
				ormLoggerFactory = new NullLoggerFactory();
			}
		}
		return ormLoggerFactory.logger(clazz);
	}

}
